package soal.markov

import org.scalatest.{Matchers, FlatSpec}
import java.util.Random
import soal.util.CassovaryUtil

class BidirectionalTransitionEstimatorSpec extends FlatSpec with Matchers {
  val graph = CassovaryUtil.readGraph("src/test/resources/test_graph.txt")
  val heatKernelT = 3
  val maxLength = (heatKernelT + 10 * math.sqrt(heatKernelT)).toInt // 10 stddev above mean
  val random = new Random(1) // Seed for consistent tests
  val estimator = new BidirectionalTransitionEstimator(graph, heatKernelT, maxLength, random)
/*
  "BidirectionalTransitionEstimator.estimateHeatKernel" should "match monte Carlo " +
    "graph" in {
    val walkCount = 100 * 1000
    val tol = 0.01f
    val relativeError = 0.05f
    val minimumProbability = 1.0f / 100
    for (s <- List(0, 1, 2)) {
      val trueScores = estimator.monteCarloHeatKernel(s, walkCount)
      for (t <- 0 until 10) {
        withClue (s"Testing Pair ($s, $t)") {
          val estimate = estimator.heatKernel(s, t, minimumProbability, relativeError, None)
          println(s"($s, $t): " + estimate + " should be " + trueScores(t))
          estimate should equal(trueScores(t) +- tol)
        }
      }
    }
  }

  "BidirectionalTransitionEstimator.forwardPushHeatKernel" should "match monte Carlo " +
    "graph" in {
    val walkCount = 100 * 1000
    val tol = 0.01f
    val epsilon = tol
    for (s <- List(0, 1, 2)) {
      val trueScores = estimator.monteCarloHeatKernel(s, walkCount)
      val forwardScores = estimator.forwardPushHeatKernel(s, epsilon)
      for (t <- 0 until 10) {
        withClue (s"Testing Pair ($s, $t)") {
          println(s"($s, $t): " + forwardScores(t) + " should be " + trueScores(t))
          forwardScores(t) should equal(trueScores(t) +- tol)
        }
      }
    }
  }
  */
}
